import { Injectable } from '@angular/core';
import { HttpInterceptor, HttpEvent, HttpHandler, HttpRequest, HttpResponse } from '@angular/common/http';
import { Observable } from 'rxjs';
import { tap } from 'rxjs/operators';
import { Router } from '@angular/router'
import { NzMessageService } from 'ng-zorro-antd/message';
const ignoreToken = ['login', 'logout', 'table'];
// @Injectable()
export class HttpInterceptorService implements HttpInterceptor {
  constructor(private router: Router, private msg: NzMessageService) { }
  intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
    // alert(6)
    // 先补全请求协议
    let url = req.url;
    const needToken = ignoreToken.filter(u => url.match(u));
    // if (url.indexOf('http://') < 0 || url.indexOf('https://') < 0) {
    //   url = 'http://' + url;
    // }
    // 过滤掉不需要token的请求
    if (!needToken.length) {
      req = req.clone({
        url
      });
    } else {
      req = req.clone({
        url,
        headers: req.headers.set('token', 'asdqwe')
      });
    }
    return next.handle(req).pipe(
      tap(
        event => {
          if (event instanceof HttpResponse) {
            let that = this;
            if (event.body == 520) {
              // 登录失效
              // console.log('event登录失效')
              // that.msg.error('您的登录已失效，请重新登录！', {
              //   nzDuration: 3000
              // });
              setTimeout(() => {
                that.router.navigateByUrl('login');
              }, 2000);
              localStorage.removeItem('user')
              localStorage.removeItem('menu')
              localStorage.removeItem('phones')
              localStorage.removeItem('index')
              return;
            }
            else if (event.status == 500) {
              // 系统异常
              console.log('event系统异常')
              // that.msg.error(event.body.remarks, {
              //   nzDuration: 2000
              // });
              return
            }
          }
        },
        error => {
          // console.log(error)
          let that = this;
          if (error.error && error.error.text == 520) {
            // 登录失效
            setTimeout(() => {
              that.router.navigateByUrl('login');
              localStorage.removeItem('user')
              localStorage.removeItem('menu')
              localStorage.removeItem('phones')
              localStorage.removeItem('index')
            }, 2000);
            return
          }
          else if (error.status == 500) {
            // 系统异常
            console.log('error系统异常，请重试！')
            // that.msg.error('error系统异常，请重试！', {
            //   nzDuration: 3000
            // });
            return
          }

        })
    );
  }
}
