import { Injectable } from '@angular/core';
import { Subject, Observable, from } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class WebsocketPhoneService {

  constructor() { }


  ws: WebSocket;//定义websocket
  private subject;
  flag = 1;//是否自动重连,1,正常,2，关闭，3，重连
  // 连接websocket
  connectWs(url, data): Observable<any> {
    var postData = data;
    if (this.ws != null) { this.ws.close() };
    if (this.subject) { this.subject = null };
    this.ws = new WebSocket(url);
    this.subject = new Subject<any>();
    let that = this;
    this.ws.onopen = function (event) {
      //socket 开启后执行，可以向后端传递信息
      var sendData = JSON.stringify(postData)
      that.ws.send(sendData);
      console.log('open')
    }
    this.ws.onmessage = function (event) {
      //socket 获取后端传递到前端的信息
      console.log('onmessage')
      if (event.data && event.data.length > 1) {
        that.subject.next(JSON.parse(event.data));
      }
    }

    this.ws.onerror = function (event) {
      //socket error信息
      console.log('error')

    }
    this.ws.onclose = function (event) {
      //socket 关闭后执行
      console.log('close')
      console.log('websocket 断开: ' + event.code + ' ' + event.reason + ' ' + event.wasClean)
      if(event.wasClean){
        that.flag = 2;
      }else{
        that.flag = 3;
      }
    }

    return that.subject.asObservable();
  }

  // 断开websocket,true关闭，false，断线重连
  closeWs() {
    this.ws.close()
  }
}

